function [bst,context,A,C,T,L,tbar]=Encode_Sign(bp,sigma,sgn,j1,j2,context,A,C,T,L,tbar)

[M,N]=size(bp);
bst=[];
Xh = 0;
if (j2>1)
    Xh = sgn(j1,j2-1)*sigma(j1,j2-1);
end
if (j2<N)
    Xh=Xh+sgn(j1,j2+1)*sigma(j1,j2+1);
end

Xv = 0;
if (j1>1)
    Xv = sgn(j1-1,j2)*sigma(j1-1,j2);
end
if (j1<M)
    Xh=Xh+sgn(j1+1,j2)*sigma(j1+1,j2);
end

Xh = sign(Xh)*min(1,abs(Xh));
Xv = sign(Xv)*min(1,abs(Xv));

if (Xh == 1)
   k_sign = 13 + Xv;
   X_flip = 1;
else
    if (Xh == 0)
        k_sign = 10 + abs(Xv);
        if (Xv == -1)
            X_flip = -1;
        else
            X_flip = 0;
        end
    else
        % Xh ==-1
        k_sign = 13 - Xv;
        X_flip = -1;
    end
end

if (sgn(j1,j2)*X_flip==1)
   [bs,context,A,C,T,L,tbar]=MQ_Encode(0,k_sign,context,A,C,T,L,tbar);
   bst = [bst bs];
else
   [bs,context,A,C,T,L,tbar]=MQ_Encode(1,k_sign,context,A,C,T,L,tbar);
   bst = [bst bs]; 
end