function [bst,context,sigma,A,C,T,L,tbar,coded]=MQ_Ecoder_Pass2(bp,sigma,sgn,ppi,context,A,C,T,L,tbar,subband)
% Magnitude refinement
% Define the context for k_run and kuni
krun = 9;
kuni = 18;

[M,N] = size(bp);
nStripes = ceil(M/4);
bst = [];
coded=zeros(M,N);

for n=1:nStripes
    str = bp(4*(n-1)+1:min(4*n,M),1:N);
    M2 = size(str,1);
    for j2=1:N
        for j1=1:M2
            r=-1;
            if (j1==1 && M2==4) % Entering a full stripe column
                i=0;
                ksig=find_ksig(sigma,j1+i+4*(n-1),j2,subband);
                while (and(ksig == 0,i<3))
                    i = i+1;
                    ksig=find_ksig(sigma,j1+i+4*(n-1),j2,subband);
                end
                if (and(i==3,ksig ==0)==1)
                   r=0;
                   r2=find(str(j1:j1+3,j2)==1,1,'first'); %Find the first 1
                   if (r2<=4)
                       r=r2-1;
                   else
                       r=4;
                   end
                   if (r==4)
                      [bs,context,A,C,T,L,tbar]=MQ_Encode(0,krun,context,A,C,T,L,tbar);
                      bst = [bst bs];
                   else
                      [bs,context,A,C,T,L,tbar]=MQ_Encode(1,krun,context,A,C,T,L,tbar);
                      bst = [bst bs];
                      [bs,context,A,C,T,L,tbar]=MQ_Encode(fix(r/2),kuni,context,A,C,T,L,tbar);
                      bst = [bst bs];
                      [bs,context,A,C,T,L,tbar]=MQ_Encode(mod(r,2),kuni,context,A,C,T,L,tbar);
                      bst = [bst bs];
                   end
                end
            end
            
            if ((sigma(j1+4*(n-1),j2)==0) && ppi(j1+4*(n-1),j2)==0)
               if (r >=0 )
                  r=r-1; % No need to code significance 
                  coded(j1+4*(n-1):j1+4*(n-1)+3,j2)=1;
               else
                  ksig=find_ksig(sigma,j1+4*(n-1),j2,subband); 
                  x=str(j1,j2);
                  coded(j1+4*(n-1),j2)=1;
                  [bs,context,A,C,T,L,tbar]=MQ_Encode(x,ksig,context,A,C,T,L,tbar);
                  bst = [bst bs];
                  if (x==1)
                     sigma(j1+4*(n-1),j2)=1;
                     [bs,context,A,C,T,L,tbar]=Encode_Sign(bp,sigma,sgn,j1+4*(n-1),j2,context,A,C,T,L,tbar);
                     bst = [bst bs];
                  end
               end
            end
        end
    end
end