function [lm2,p2,lm,prob,nelements]=huffmanEncoder(DC)

DC2=[0 DC(1:length(DC)-1)];
DCdif=DC-DC2;
DCmin=min(DCdif);
DCmax=max(DCdif);
figure;[nelements,xcenters]=hist(DCdif,DCmax-DCmin);
prob=nelements/sum(nelements);
stem(xcenters,prob);
p2 = prob(prob ~= 0); %Delete the elements with zero probability
h=huffman(p2); % Find the huffman code for each symbol with prob in p2

s=size(h);
lm2=zeros(1,s(1));
for j=1:s(1)
    lm2(j)=length(h{j});
end

Entropy = sum(log2(1./p2).*p2);

h=huffman(prob); % Find the huffman code for each symbol with prob p
s=size(h);
lm=zeros(1,s(1));
for j=1:s(1)
    lm(j)=length(h{j});
end
